package FTPup;

# 炶Plugin
# FTPup.pm ver:1.01
# 

use 5.006;
use strict;
use warnings;
use Socket;

require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);
use vars qw($revision $VERSION);

$revision = '$Id: FTPup.pm,v 1.01 2004/07/18 18:00:00 lstein Exp $';
$VERSION='1.01';

our $DefaultClass = 'FTPup';
our $debug = 0;

sub new {
    my ($class) = @_;
    shift if ($class && $class eq $DefaultClass);
    my $self = {};
    bless $self,$DefaultClass;
}

###############################
# FTP֘A
###############################

sub ftp_open {
    my ($pkg, $sock, $host, $port) = arg_check(@_);
    my ($ip, $sockaddr);

    # \Pbg
    $ip = inet_aton($host) || die "host($host) not found.\n";
    $sockaddr = pack_sockaddr_in($port, $ip);
    socket($sock, PF_INET, SOCK_STREAM, 0) || die "socket error.\n";

    # ڑ
    print "Starting connect [$host:$port]\n" if $debug;
    connect($sock, $sockaddr) || die "connect $host $port error.\n";
    autoflush $sock (1);
}

# FTPڑI
sub ftp_close {
    my ($pkg, $sock) = arg_check(@_);
    close($sock);
}

# FTPR}hM
sub ftp_send {
    my ($pkg, $sock, $cmd, @opt) = arg_check(@_);

    if ($#opt) {
        print $sock "$cmd\n";
        print "$cmd\n" if $debug;
    } else {
        print $sock "$cmd @opt\n";
        print "$cmd @opt\n" if $debug;
    }
}

# FTPX|XM
sub ftp_recv {
    my ($pkg, $sock) = arg_check(@_);
    my ($buf, $code, $cont, $msg);

    my $rc = 0;
    while (chomp($buf=<$sock>)) {
        $buf =~ /^(\d\d\d)([ |-])(.*)/;
        $code = $1;
        $cont = $2;
        $msg = $3;
        print "$buf\n" if ($debug || $code == 221 || $code == 230 || $code > 400);
        if ($cont ne '-') { last; }
    }
    return($buf);
}

sub get_pasv_port {
    my ($pkg, $buf) = arg_check(@_);
    my ($host, $port);

    $buf =~ /^2\d\d .*\((\d+,\d+,\d+,\d+),(\d+),(\d+)\)/;
    $host = $1;
    $port = $2 * 256 + $3;
    $host =~ s/,/\./g;

    return($host, $port);
}

########################
#
# FTPR}h֐
#
# putR}h
sub ftp_put {
    my ($pkg, $sock, $cmd, $file, @dat) = arg_check(@_);
    my ($host, $port, $buf, $pid);
    my ($data);

    # PASV[hɕύX
    &ftp_send($sock, 'PASV');
    $buf = &ftp_recv($sock);
    ($host, $port) = &get_pasv_port($buf);

    # STORR}hM
    &ftp_send($sock, 'STOR', $file);
    if ($pid = fork()) {
        $buf = &ftp_recv($sock);
        if ($buf =~ /^5/) { kill 'TERM', $pid; return; }
        wait;
        $buf = &ftp_recv($sock);

    } else {
        $data = new FileHandle;
        &ftp_open($data, $host, $port);

        foreach (@dat) {
            print $data $_;
        }

        &ftp_close($data);
        exit(0);
    }
}


sub arg_check {
    return @_ if defined($_[0]) && (!ref($_[0])) &&($_[0] eq $DefaultClass);
    our ($cls);
    unless (defined($_[0]) && (ref($_[0]) eq $DefaultClass || UNIVERSAL::isa($_[0],$DefaultClass))) {
        $cls = $DefaultClass->new() unless defined($cls);
        unshift(@_, $cls);
    }
    return wantarray ? @_ : $cls;
}

1;
