package RoFX;

# 炶Plugin
# RoFX.pm ver:1.01
#

use 5.006;
use strict;
use warnings;
use Socket;

require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);
use vars qw($revision $VERSION);

$revision = '$Id: RoFX.pm,v 1.01 2005/12/18 23:45:00 lstein Exp $';
$VERSION='1.01';

our $DefaultClass = 'RoFX';

our %clss = (
    SYS => 'SYS',
    GMM => 'GM',
    GVG => 'GM',
    WIS => 'WIS',
    GLD => 'GLD',
    PTY => 'PT',
    CHA => 'OPN'
);

sub new {
    my ($class) = @_;
    shift if ($class && $class eq $DefaultClass);
    my $self = {
        class => \%clss
    };
    bless $self,$DefaultClass;
}

# &dayfile(YYYY,MM,DD,dir,chara,server)
# t@CʒuԂ
sub dayfile {
    my ($pkg, $year, $month, $day, $dir, $chara, $server) = arg_check(@_);
    my ($newer, $path);
    $server = lc($server);
    my $dayfile = sprintf("%02d%02d%02d.txt",$year-2000,$month,$day);

    $newer = (-M "$dir/$server\_$dayfile");
    if ($chara) {
        my $tmp = (-M "$dir/$server\_$chara\_$dayfile");
        if ($tmp && (!$newer || $tmp < $newer)) {
            $newer = $tmp;
        } else {
            $chara = '';
        }
    }
    if ($chara) {
        $path = "$dir/$server\_$chara\_$dayfile";
    } else {
        $path = "$dir/$server\_$dayfile";
    }
    return wantarray ? ($path, $chara) : $path;
}

# linesplit(line)
# ÖsAʁAԁAf[^ɐ؂蕪
sub linesplit {
    my ($pkg, $line) = arg_check(@_);
    my ($tcls, $class);
    if ($line) {
        $line =~ /^\[(\d+:\d+:\d+)\](?:\[[-_a-zA-Z0-9]+\])?\[(\w+)\]\s(.+)/;
        if ($2) {
            $class = $clss{$2};
        } else {
            $class = '___';
        }
        return ($class, $1, $3);
    } else {
        return undef;
    }
}

# sys_decompose(dat)
# VXeO̔F
sub sys_decompose {
    my ($pkg, $dat) = arg_check(@_);
    if ($dat =~ /^\*==== OC܂   ==================================\*$/) {
        return wantarray ? ('login', $1) : 'login';
    } elsif ($dat =~ /^\*==== OAEg܂ ==================================\*$/) {
        return wantarray ? ('logout', $1) : 'logout';
    }
}

# wis_decompose(dat)
# wis̕
sub wis_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ($1, $2);
}

# opn_decompose(dat)
# ʏb̕
sub opn_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ($1, $2);
}

sub arg_check {
    return @_ if defined($_[0]) && (!ref($_[0])) &&($_[0] eq $DefaultClass);
    our ($cls);
    unless (defined($_[0]) && (ref($_[0]) eq $DefaultClass || UNIVERSAL::isa($_[0],$DefaultClass))) {
        $cls = $DefaultClass->new() unless defined($cls);
        unshift(@_, $cls);
    }
    return wantarray ? @_ : $cls;
}

1;
