package Ropp;

# 炶Plugin
# Ropp.pm ver:1.10
# 


use 5.006;
use strict;
use warnings;
use Socket;

require Exporter;

our @ISA = qw(Exporter);

our %EXPORT_TAGS = ( 'all' => [ qw(
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
);
use vars qw($revision $VERSION);

$revision = '$Id: Ropp.pm,v 1.10 2004/07/09 21:45:00 lstein Exp $';
$VERSION='1.10';

our $DefaultClass = 'Ropp';

our %clss = (
    SYS => 'SYS',
    GM => 'GM',
    WHIS => 'WIS',
    GILD => 'GLD',
    PART => 'PT',
    NORM => 'OPN'
);

sub new {
    my ($class) = @_;
    shift if ($class && $class eq $DefaultClass);
    my $self = {
        class => \%clss
    };
    bless $self,$DefaultClass;
}

# &dayfile(YYYY,MM,DD,dir,chara,server)
# t@CʒuԂ
sub dayfile {
    my ($pkg, $year, $month, $day, $dir, $chara, $server) = arg_check(@_);
    my ($newer, $path);
    our @chara;

    unless (@chara) {
        opendir(DIR, $dir);
        while (defined(my $chrdir = readdir(DIR))) {
            push (@chara, $chrdir) if ($chrdir ne '..' && $chrdir ne '.');
        }
        closedir(DIR);
    }

    my $dayfile = sprintf("%d_%02d_%02d.txt",$year,$month,$day);
    $newer = (-M "$dir/$dayfile");
    if ($chara) {
        my $tmp = (-M "$dir/$chara/$dayfile");
        if ($tmp && (!$newer || $tmp < $newer)) {
            $newer = $tmp;
        } else {
            $chara = '';
        }
    } else {
        foreach (@chara) {
            my $tmp = (-M "$dir/$_/$dayfile");
            if ($tmp && (!$newer || $tmp < $newer)) {
                $newer = $tmp;
                $chara = $_;
            }
        }
    }
    if ($chara) {
        $path = "$dir/$chara/$dayfile";
    } else {
        $path = "$dir/$dayfile";
    }
    return wantarray ? ($path, $chara) : $path;
}

# linesplit(line)
# ÖsAʁAԁAf[^ɐ؂蕪
sub linesplit {
    my ($pkg, $line) = arg_check(@_);
    my ($class);
    if ($line) {
        $line =~ /^(\w+?)\s+(\d+:\d+:\d+)\s(.+)/;
        if ($1) {
            $class = $clss{$1};
        } else {
            $class = '___';
        }
        return ($class, $2, $3);
    } else {
        return undef;
    }
}

# sys_analysis(dat)
# VXeO̔F
sub sys_decompose {
    my ($pkg, $dat) = arg_check(@_);
    if ($dat =~ /^\[OC\]/) {
        return wantarray ? ('login') : 'login';
    } elsif ($dat =~ /^\[OAEg\]/) {
        return wantarray ? ('logout') : 'logout';
    }
}

# wis_analysis(dat)
# wis̕
sub wis_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ($1, $2);
}

# wis_analysis(dat)
# wis̕
sub opn_decompose {
    my ($pkg, $dat) = arg_check(@_);
    $dat =~ /^(.+?)\s:\s(.+)/;
    return ($1, $2);
}

sub arg_check {
    return @_ if defined($_[0]) && (!ref($_[0])) &&($_[0] eq $DefaultClass);
    our ($cls);
    unless (defined($_[0]) && (ref($_[0]) eq $DefaultClass || UNIVERSAL::isa($_[0],$DefaultClass))) {
        $cls = $DefaultClass->new() unless defined($cls);
        unshift(@_, $cls);
    }
    return wantarray ? @_ : $cls;
}

1;
